#include <Profiles/HeartRate/DataPages/TX/ANTPLUS_HeartRateCumulativeOperatingTimeMsg.h>
#include <Profiles/HeartRate/ANTPLUS_HeartRatePrivateDefines.h>
#include <ANTPLUS_PrivateDefines.h>

HeartRateCumulativeOperatingTimeMsg::HeartRateCumulativeOperatingTimeMsg() : HeartRateBaseMainDataPageMsg(ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_NUMBER) {

}

uint32_t HeartRateCumulativeOperatingTimeMsg::getCumulativeOperatingTime() {
    uint32_t time = _buffer[ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_LSB_BYTE];
    time |= _buffer[ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MID_BYTE] << ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MID_SHIFT;
    time |= _buffer[ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MSB_BYTE] << ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MSB_SHIFT;
    return time;
}

void HeartRateCumulativeOperatingTimeMsg::setCumulativeOperatingTime(uint32_t time) {
    _buffer[ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_LSB_BYTE] = ANTPLUS_DEFAULT_BYTE_MASK & time;
    _buffer[ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MID_BYTE] = ANTPLUS_DEFAULT_BYTE_MASK & (time >> ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MID_SHIFT);
    _buffer[ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MSB_BYTE] = ANTPLUS_DEFAULT_BYTE_MASK & (time >> ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MSB_SHIFT);
}
